<p align="center">
  <a href="https://www.meetup.com/Angular-Medellin/">
    <img src="https://s1.ax1x.com/2020/07/19/UW2eVx.png" alt="UW2eVx.png" border="0" height="20%" width="20%"/>
  </a>
</p>

<p align="center">
    <a>
        <img src="https://img.shields.io/badge/python-v3-blue" alt="UW2eVx.png" />
    </a>
    <a>
        <img src="https://img.shields.io/badge/platform-Windows-blue" alt="UW2eVx.png" />
    </a>
    <a>
        <img src="https://img.shields.io/website?up_message=%E4%BD%BF%E7%94%A8%E6%96%87%E6%A1%A3&url=https%3A%2F%2Finfospider.vercel.app%2F" alt="UW2eVx.png" />
    </a>

</p>
<p align="center">一个神奇的工具箱，拿回你的个人信息。</p>
<p align="center"><a href="https://infospider.vercel.app/">使用说明文档</a> | <a href="https://www.bilibili.com/video/BV14f4y1R7oF/">视频演示 ️</a></p>

***
# 🕷About
INFO-SPIDER 是一个集众多数据源于一身的爬虫工具箱，旨在安全快捷的帮助用户拿回自己的数据，工具代码开源，流程透明。并提供数据分析功能，基于用户数据生成图表文件，使得用户更直观、深入了解自己的信息。
目前支持数据源包括GitHub、QQ邮箱、网易邮箱、阿里邮箱、新浪邮箱、Hotmail邮箱、Outlook邮箱、京东、淘宝、支付宝、中国移动、中国联通、中国电信、知乎、哔哩哔哩、网易云音乐、QQ好友、QQ群、生成朋友圈相册、浏览器浏览历史、12306、博客园、CSDN博客、开源中国博客、简书。

详细使用说明参照[使用说明文档](https://infospider.vercel.app)或[视频教程](https://www.bilibili.com/video/BV14f4y1R7oF/)

# 🎨Screenshot

![screenshot.png](https://i.loli.net/2020/07/19/HUDljdTazJQA6hX.png ':size=70%')

# 🚀QuickStart

## 依赖安装

1. 安装[python3](https://www.python.org/downloads/)和Chrome浏览器

2. 安装与Chrome浏览器相同版本的[驱动](http://chromedriver.storage.googleapis.com/index.html)

3. 安装依赖库 `pip install -r requirements.txt`

## 工具运行

1. 进入 tools 目录

2. 运行 `python3 main.py`

3. 在打开的窗口**点击数据源按钮**, 根据提示**选择数据保存路径**

4. 弹出的浏览器**输入用户密码**后会自动开始爬取数据, 爬取完成浏览器会自动关闭.
   
5. 在对应的目录下可以**查看下载下来的数据**(xxx.json), **数据分析图表**(xxx.html)


# 🌈数据源
- [x] GitHub
- [x] QQ邮箱
- [x] 网易邮箱
- [x] 阿里邮箱
- [x] 新浪邮箱
- [x] Hotmail邮箱
- [x] Outlook邮箱
- [x] 京东
- [x] 淘宝
- [x] 支付宝
- [x] 中国移动
- [x] 中国联通
- [x] 中国电信
- [x] 知乎
- [x] 哔哩哔哩
- [x] 网易云音乐
- [x] QQ好友
- [x] QQ群
- [x] 生成朋友圈相册
- [x] 浏览器浏览历史
- [x] 12306
- [x] 博客园
- [x] CSDN博客
- [x] 开源中国博客
- [x] 简书

# ⚖️数据分析

- [x] 博客园
- [x] CSDN博客
- [x] 开源中国博客
- [x] 简书

# 📑计划

- 对爬取的个人数据进行统计分析
- 融合机器学习技术、自然语言处理技术等对数据深入分析
- 把分析结果绘制图表直观展示
- 添加更多数据源...


# 😇Visitors

![](http://profile-counter.glitch.me/kangvcar/count.svg)

# 📌Changelog
<details>
<summary>点击展开 Changelog</summary>

- 2020年7月10日
    1. 更新GUI布局
    2. 添加GitHub、QQ好友、QQ群数据源

- 2020年7月12日
    1. 修复QQ邮箱、网易邮箱、阿里邮箱、新浪邮箱、Hotmail、Outlook数据源
    2. 添加生成朋友圈相册功能

- 2020年7月14日
    1. 修复京东、淘宝、支付宝、12306数据源
    2. 添加Chrome浏览记录功能

- 2020年7月17日
    1. 修复中国移动、中国联通数据源
    2. 添加知乎、哔哩哔哩、网易云音乐数据源

- 2020年7月19日
    1. 添加博客园、CSDN、开源中国、简书数据源
    2. 编写[使用说明文档](https://infospider.vercel.app/)
    3. 录制使用视频教程

- 2020年7月30日
    1. 添加博客园数据分析功能
    2. 使用pyechart绘制图表并生成html文件保存在数据目录下
    
</details>
    
# License
GPL-3.0